%Ian Gemp
%The bifDiagram function obtains the data needed for a bifurcation diagram
%by varying a certain characteristic parameter of the polygon/table system
%and storing the resulting contact states of the system's steady state

function [lam,hmax,xpos,vpost,time] = bifDiagram(lam,object,state,table,params)

%declare system before using bifDiagram function
%bifDiagram will change table functions
g = -9.81;
hmax = zeros(params.hitlim-1,length(lam));
vpost = zeros(params.hitlim-1,length(lam));
% 3.4 - 7.4 m/s^2 at peak amplitude
%try 3 - 8 and find out what that means for lamda
%plot ball peaks on y axis
time = cputime;

for ii=1:length(lam)
    table.y = [num2str(lam(ii)),'*9.81/(2*pi*30)^2*cos(2*pi*30*t)'];
    table.cloudmax = lam(ii)*9.81/(2*pi*30)^2;
    %table.phi = [num2str(lam(ii)),'*pi/180*cos(pi*30*t+pi/2)'];
    %set table function based on lam(ii)
    [F,contstates] = polysim(object,state,table,params,3);
    disp('Succesful Impacts: ',num2str(length(contstates{1}));
    while length(contstates{1})<10
        state.y = 2*state.y;
        [F,contstates] = polysim(object,state,table,params,3);
    end
    for jj=2:length(contstates{2})
        hmax(jj-1,ii) = contstates{2}(jj).y - 1/2*contstates{2}(jj).yd^2/g;
        xpos(jj-1,ii) = contstates{2}(jj).x;
        vpost(jj-1,ii) = contstates{2}(jj).yd;
    end
    %clear contstates F table.y table.cloudmax
    clear contstates F table.phi
    disp('Percent Completion: ',num2str(ii/length(lam)*100),' %');
    disp('Lambda: ',num2str(lam(ii)));
end

time = cputime-time;

%{
object.nvert = 1;
object.x = 0;
object.y = 0;
object.r = 0.0048e-2;
object.theta = 0;
object.inertia = 1;
object.u = 0;
object.res = .8;
state.x = 0;
state.xd = 0;
state.y = 1e-2+object.r;
state.yd = 0;
state.theta = 0;
state.thetad = 0;
table.phi = '0';
table.x = '0';
params.step = .001;
params.stepmov = .02;
params.T = 5;
params.hitlim = 500;
params.windim = [-5e-2 5e-2 -2e-2 8e-2];
lam = [0:.01:2];
%make sure table.y and table.cloudmax are defined in the bifDiagram.m
[lam,hmax,xpos,vpost,time] = bifDiagram(lam,object,state,table,params);
plot(lam,hmax(end-9:end,:),'*');
%}