%Ian Gemp


function newstates = datarecon(contact_time1,contact_time2,contact_state1,stepmov)
%dataRecon reconstructs the object states between two contact instances

%stepmov is desired time step for a movie
%contact_states specifies the object position and the contact time at two contacts
%contact_state1 is treated as an initial state at t=0

%gravitational acceleration
g = -9.81;

t=mod(contact_time1,stepmov);
%hopefully this keeps the data equally spaced by a time step of stepmov

%store new states
numstates = round((contact_time2-contact_time1-t)/stepmov)-1;
newstates = cell(numstates,1);

jj = 1;
while t<(contact_time2-contact_time1)
    
	%predict next object position
    tempstate.x = contact_state1.x + contact_state1.xd*t;
    tempstate.y = contact_state1.y + contact_state1.yd*t + 1/2*g*t^2;
    tempstate.theta = contact_state1.theta + contact_state1.thetad*t;
    tempstate.xd = contact_state1.xd;
    tempstate.yd = contact_state1.yd + g*t;
    tempstate.thetad = contact_state1.thetad;
	%store object state
    newstates{jj} = tempstate;
	%update time
    t = t + stepmov;
    %go to next state
    jj = jj + 1;
    
end