%period 1 stability
%clear all
%clc

g = -9.81;
%get from bifurcation data

%data for 1.05g's
%
res = .8;
%y0 = [3e-4 3.5e-4 4e-4];
A = 1.05*9.81/(2*pi*30)^2;
w = 2*pi*30;
%}

tol = 1e-6;

%{
res = 1;
y0 = 2;
v0 = 0;
A = 1;
w = 1;
%}

%Basic Idea: these are old ideas (probably wrong)
%We start the ball from a contact with the table and give the ball some
%upward velocity.  We see where the ball lands.  If the ball lands closer
%to the fixed point than where we started it, then the fixed point is
%table.  If not, then the fixed point is unstable.
%Alternative Approach:
%We staart the ball from contact with the table and give the ball some
%upward velocity.  We see what the velocity of the ball is after the next
%impact.  If the ball's velocity approached the fixed point velocity, then
%the fixed point is table (otherwise, its unstable).
%New Idea:
%Drop the ball from a set height at t=0 and vary the ball height.  This way
%both the initial contact position and velocity will change.

%
%Taylor series of A*sin(w*t) about t=0 for table y position
n = 25; %must be odd
tfun = zeros(1,n+1);
for i=n:-2:1
    tfun(n-i+1) = (-1)^(mod(i-3,4)/2+1)*A*(w^i)/factorial(i);
end
tfun(n+1) = 0;
%Taylor series of A*w*cos(w*t) about t=0 for table y velocity
vtfun = zeros(1,n+1);
for i=n-1:-2:0
    vtfun(n-i+1) = (-1)^((mod(i-3,4)+1)/2+1)*A*w*(w^i)/factorial(i);
end
%}
%{
%Taylor series of A*cos(w*t) about t=0 for table y position
n = 22; %must be even
tfun = zeros(1,n+1);
for i=n:-2:0
    tfun(n-i+1) = (-1)^((mod(i-3,4)+1)/2+1)*A*(w^i)/factorial(i);
end
%Taylor series of -A*w*sin(w*t) about t=0 for table y velocity
vtfun = zeros(1,n+1);
for i=n-1:-2:1
    vtfun(n-i+1) = -(-1)^(mod(i-3,4)/2+1)*A*w*(w^i)/factorial(i);
end
vtfun(n+1) = 0;
%}

%set ball initial position and velocity
phi = acos(-pi*g/(A*w^2)*(1-res)/(1+res))
t = phi/w;
tyc = 0;
vtc = 0;
for i=n+1:-1:1
    tyc = tyc + t^(i-1)*tfun(n+2-i);
    vtc = vtc + t^(i-1)*vtfun(n+2-i);
end
stable_pos = tyc;
v1 = -g*pi/w;
vc = -(v1-vtc)/res + vtc;
v0 = vc - g*t;
y0 = tyc - v0*t - 1/2*g*t^2;
y0 = [y0,y0+1e-4,y0-1e-4];

c = lines(length(y0)+2);


for m=1:length(y0)

    %Polynomial for ball y position
    bfun(m,:) = zeros(1,n+1);
    bfun(m,end-2:end) = [1/2*g,v0,y0(m)];
    %Polynomial for ball y velocity
    vbfun(m,:) = zeros(1,n+1);
    vbfun(m,end-1:end) = [g,v0];

    %Find contact time between ball and table
    contactPoly = bfun(m,:)-tfun;
    r = roots(contactPoly);
    ind = 0;
    for k = 1:length(r)
        ind(k) = (isreal(r(k))&r(k)>tol);
    end
    dt(m) = min(r(logical(ind)));

    %Find ball and table's y velocity and position at impact
    vbc = 0;
    vtc = 0;
    tyc = 0;
    byc = 0;
    for i=n+1:-1:1
        vbc = vbc + dt(m)^(i-1)*vbfun(m,n+2-i);
        vtc = vtc + dt(m)^(i-1)*vtfun(n+2-i);
        tyc = tyc + dt(m)^(i-1)*tfun(n+2-i);
        byc = byc + dt(m)^(i-1)*bfun(m,n+2-i);
    end
    
    error0 = w*(dt(m)-t);
    if m>1
        disp(['Phase Error of Ball ',num2str(m),' in Radians: ',num2str(error0)]);
    end

    %Find ball's velocity after impact
    v1 = -res*(vbc-vtc)+vtc;
    %fprintf('Initial velocity = %16.8f.\n',v1)
    
    %
    %New Polynomial for ball y position
    bfun1(m,:) = zeros(1,n+1);
    bfun1(m,end-2:end) = [1/2*g,v1-g*dt(m),byc-v1*dt(m)+1/2*g*(dt(m)^2)];
    %Polynomial for ball y velocity
    vbfun1(m,:) = zeros(1,n+1);
    vbfun1(m,end-1:end) = [g,v1-g*dt(m)];

    %Find new contact time between ball and table
    contactPoly1 = bfun1(m,:)-tfun;
    r = roots(contactPoly1);
    ind = 0;
    for k = 1:length(r)
        ind(k) = (isreal(r(k))&r(k)>(dt(m)+tol));
    end
    dt1(m) = min(r(logical(ind)));

    %Find new ball and table's y velocity and position at impact
    vbc1 = 0;
    vtc1 = 0;
    tyc1 = 0;
    byc1 = 0;
    for i=n+1:-1:1
        vbc1 = vbc1 + dt1(m)^(i-1)*vbfun1(m,n+2-i);
        vtc1 = vtc1 + dt1(m)^(i-1)*vtfun(n+2-i);
        tyc1 = tyc1 + dt1(m)^(i-1)*tfun(n+2-i);
        byc1 = byc1 + dt1(m)^(i-1)*bfun1(m,n+2-i);
    end
    error1 = w*(dt1(m)-(t+2*pi/w));
    if m>1
        disp(['New Phase Error of Ball ',num2str(m),' in Radians: ',num2str(error1)]);
        disp(['Absolute Final_Error/Initial_Error of Ball ',num2str(m),': ',num2str(abs(error1/error0))]);
    end
end

%Plot table and ball trajectories
count = 1;
table_y = 0;
table_vy = 0;
ball_y = 0;
ball_vy = 0;
for j=0:dt(1)/100:dt(1)
    vb = 0;
    %vt = 0;
    %ty = 0;
    by = 0;
    for i=n+1:-1:1
        vb = vb + j^(i-1)*vbfun(1,n+2-i);
        %vt = vt + j^(i-1)*vtfun(n+2-i);
        %ty = ty + j^(i-1)*tfun(n+2-i);
        by = by + j^(i-1)*bfun(1,n+2-i);
    end
    %table_y(count) = ty;
    %table_vy(count) = vt;
    ball_y(count) = by;
    ball_vy(count) = vb;
    count = count + 1;
end
for j=dt(1)+dt(1)/100:dt(1)/100:dt1(1)
    vb = 0;
    %vt = 0;
    %ty = 0;
    by = 0;
    for i=n+1:-1:1
        vb = vb + j^(i-1)*vbfun1(1,n+2-i);
        %vt = vt + j^(i-1)*vtfun(n+2-i);
        %ty = ty + j^(i-1)*tfun(n+2-i);
        by = by + j^(i-1)*bfun1(1,n+2-i);
    end
    %table_y(count) = ty;
    %table_vy(count) = vt;
    ball_y(count) = by;
    ball_vy(count) = vb;
    count = count + 1;
end
plot(0:dt(1)/100:dt1(1),ball_y,'Color',c(1,:))
%legend('table',['ball',num2str(m)]);
hold on
if length(y0)>1
    for p=2:length(y0)
        count = 1;
        %table_y = 0;
        %table_vy = 0;
        ball_y = 0;
        ball_vy = 0;
        for j=0:dt(p)/100:dt(p)
            vb = 0;
            %vt = 0;
            %ty = 0;
            by = 0;
            for i=n+1:-1:1
                vb = vb + j^(i-1)*vbfun(p,n+2-i);
                %vt = vt + j^(i-1)*vtfun(n+2-i);
                %ty = ty + j^(i-1)*tfun(n+2-i);
                by = by + j^(i-1)*bfun(p,n+2-i);
            end
            %table_y(count) = ty;
            %table_vy(count) = vt;
            ball_y(count) = by;
            ball_vy(count) = vb;
            count = count + 1;
        end
        for j=dt(p)+dt(p)/100:dt(p)/100:dt1(p)
            vb = 0;
            %vt = 0;
            %ty = 0;
            by = 0;
            for i=n+1:-1:1
                vb = vb + j^(i-1)*vbfun1(p,n+2-i);
                %vt = vt + j^(i-1)*vtfun(n+2-i);
                %ty = ty + j^(i-1)*tfun(n+2-i);
                by = by + j^(i-1)*bfun1(p,n+2-i);
            end
            %table_y(count) = ty;
            %table_vy(count) = vt;
            ball_y(count) = by;
            ball_vy(count) = vb;
            count = count + 1;
        end
        plot(0:dt(p)/100:dt1(p),ball_y,'Color',c(p,:))
        %legend('table',['ball',num2str(m)]);
    end
end
count = 1;
for j=0:min(dt)/100:max(dt1)
    %vb = 0;
    vt = 0;
    ty = 0;
    %by = 0;
    for i=n+1:-1:1
        %vb = vb + j^(i-1)*vbfun1(p,n+2-i);
        vt = vt + j^(i-1)*vtfun(n+2-i);
        ty = ty + j^(i-1)*tfun(n+2-i);
        %by = by + j^(i-1)*bfun1(p,n+2-i);
    end
    table_y(count) = ty;
    table_vy(count) = vt;
    %ball_y(count) = by;
    %ball_vy(count) = vb;
    count = count + 1;
end
plot(0:min(dt)/100:max(dt1),table_y,'Color',c(end-1,:))
plot(0:min(dt)/100:max(dt1),table_vy/w,'--','Color',c(end,:))
plot([0,max(dt1)],[A A],'--',[0,max(dt1)],[-A -A],'--')
hold off
legstr = cell(length(y0)+2,1);
for i=1:length(y0)
    legstr{i} = ['Ball ',num2str(i)];
end
legstr{end-1} = 'Table Position';
legstr{end} = 'Table Velocity';
legend(legstr);
if (error1/error0<1)
    title('Period 1 Stable Fixed Point');
else
    title('Period 1 Unstable Fixed Point');
end
xlabel('Time (sec)');
ylabel('Y position (m)');