%Ian Gemp
%This zerofinder function finds the time at which the polygon and the table
%make contact.  It does this using a binary search.

function [tcontact] = zerofinder(t0,x0,y0,theta0,v0x,v0y,w0,objtheta,t1,tol,yfun,xfun,phifun,r,nvert,dttol)

%t1 = below, t0 = above
tstart = t0;
t1;
tmid = (t0+t1)/2;
dt = tmid-tstart;
%dttol = 1e-8;

error = 100;
g = -9.81;

'starting';

while ((error<0 || error>tol) && dt>dttol)
    %tmid = (t1(1)+t0(1))/2;
    dt = tmid-tstart;
    
    tabmid = yfun(tmid);
    tabmidx = xfun(tmid);
    phimid = phifun(tmid);
    
    A = tan(phimid);
    B = -1;
    C = tabmid - A*tabmidx;
    if nvert>1
        m = r*cos(theta0 + w0*dt + objtheta) + x0 + v0x*dt;
        n = r*sin(theta0 + w0*dt + objtheta) + y0 + v0y*dt + 1/2*g*(dt^2);
        distance = -(A*m + B*n + C)/sqrt(A^2 + B^2);
    else
        m = x0 + v0x*dt;
        n = y0 + v0y*dt + 1/2*g*dt^2;
        distance = -(A*m + B*n + C)/sqrt(A^2 + B^2)-r;
    end
    
    error = distance;
    
    if error<0
            t1 = tmid;
            tmid = (t0+tmid)/2;
    elseif error>=0
            t0 = tmid;
            tmid = (tmid+t1)/2;
    end
end
'finished';
tcontact = tmid;